// Generated by CoffeeScript 1.9.2
(function() {
  var db, dir, fs, parser, xml2js,
    slice = [].slice;

  fs = require('fs');

  xml2js = require('xml2js');

  dir = 'data/no-intro';

  parser = new xml2js.Parser();

  db = require('./db');

  fs.readdir(dir, function(err, files) {
    return files.forEach(function(file) {
      var filename;
      filename = dir + "/" + file;
      if (!fs.existsSync(filename)) {
        return;
      }
      return fs.readFile(filename, function(err, data) {
        return parser.parseString(data, function(err, result) {
          var company, consoleName, longConsoleName, noIntroName, ref;
          longConsoleName = result.datafile.header[0].description[0];
          ref = longConsoleName.match(/((.*?)\s-\s(?:(.*)\s-\s)?(.*))Parent-Clone/), ref[0], company = ref[1], ref[2], noIntroName = ref[3], consoleName = ref[4];
          db.run('insert or ignore into Company (name) values (?)', company);
          db.run('insert into Console (name, company, nointro_name) values (? , ? , ? ) ', consoleName, company, noIntroName);
          return result.datafile.game.forEach(function(game) {
            var bios, crc, file_name, gameName, longName, match, md5, misc, name, noIntroROM, ref1, ref2, region, sha1, size, subtitle, title, title1, title2;
            longName = game.description[0];
            noIntroROM = /(?:\[([^\]]*)\]\s)?([^\)]*)\s\(([^\)]*)\)(?:\s\(([^\)]*)\))?(?:\s\(([^\)]*)\))?(?:\s\(([^\)]*)\))?(?:\s\(([^\)]*)\))?(?:\s\(([^\)]*)\))?(?:\s\(([^\)]*)\))?(?:\s\[([^\]]*)\])?/;
            ref1 = longName.match(noIntroROM), ref1[0], bios = ref1[1], name = ref1[2], region = ref1[3], misc = 5 <= ref1.length ? slice.call(ref1, 4) : [];
            gameName = name;
            if (game.$.cloneof) {
              match = game.$.cloneof.match(noIntroROM);
              if (!match) {
                gameName = game.$.cloneof;
              } else {
                gameName = match[2];
              }
            }
            ref2 = gameName.match(/(?:(.*) - )?(.*)/), ref2[0], title1 = ref2[1], title2 = ref2[2];
            title = title2;
            subtitle = null;
            if (title1) {
              title = title1;
              subtitle = title2;
            }
            db.run('insert or ignore into Game (name, title, subtitle, bios) values (? , ? , ? , ? ) ', gameName, title, subtitle, bios ? true : false);
            region = null;
            if (game.release) {
              region = game.release[0].$.region;
              db.run('insert or ignore into Region (name) values (?)', region);
            }
            file_name = game.rom[0].$.name;
            size = parseInt(game.rom[0].$.size);
            md5 = parseInt(game.rom[0].$.md5, 16);
            crc = parseInt(game.rom[0].$.crc, 16);
            sha1 = parseInt(game.rom[0].$.sha1, 16);
            return db.run('insert or ignore into ROM (file_name, size, md5, crc, sha1, nointro_name, console, game, region) values (? , ? , ? , ? , ? , ? , ? , ? , ? ) ', file_name, size, md5, crc, sha1, longName, consoleName, gameName, region);
          });
        });
      });
    });
  });

}).call(this);
